#include "lzy.h"
#include "cfg.h"
#include "rotrect.h"
#include "game.h"
#include <math.h>
#include <stddef.h>

double tick = 0;

static void
draw_square(double size, double angle)
{
	rotrect(DISPLAY_WIDTH / 2.0, DISPLAY_HEIGHT / 2.0, size, size, angle);
}

void
background_update(Game *g)
{
	if (g != NULL && game_entity_count(g, entity_type("player")) > 0)
		tick += 1.0;
	else
		tick += 0.25;
}

void
background_draw(void)
{
	if (!tick)
		return;
	LZY_DrawSetColor(BLACK);
	draw_square(300 * sin(tick / 50), tick / 40);
	draw_square(300 * sin(tick / 40), tick / 30);
	draw_square(300 * sin(tick / 30), tick / 20);
}
